#!/usr/bin/python
# -*- coding: utf-8 -*-
#
# Pyromaths
# Un programme en Python qui permet de créer des fiches d'exercices types de
# mathématiques niveau collège ainsi que leur corrigé en LaTeX.
# Copyright (C) 2015 -- Jérôme Ortais (jerome.ortais@pyromaths.org)
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
#

from pyromaths import ex
from random import randrange, shuffle
from pyromaths.outils import Priorites3
from pyromaths.classes.Fractions import Fraction
from pyromaths.classes.PolynomesCollege import Polynome
from pyromaths.ex.lycee.SecondDegre import creerPolydegre2
from pyromaths.outils.Arithmetique import valeur_alea

class Fd6DeriveeEtVariations(ex.TexExercise):
    '''
    classdocs
    '''
    #description = u'Dérivée et sens de variation d’une fonction'
    #level = u"1.1èreS"


    def __init__(self):
        der = [creerPolydegre2(0), creerPolydegre2(1, False), creerPolydegre2(2, False)]
        n = randrange(1,5)
        der.append(Polynome([[valeur_alea(-9, 9), n+1],[valeur_alea(-9, 9), n]]))
        pol = []
        for p in der:
            pol.append(p.primitive()+Polynome('%s' % randrange(-9, 10)))
        shuffle(pol)
        self.exercice = pol

    def tex_statement(self):
        exo = [r'\exercice']
        exo.append(r'\setlength{\abovedisplayskip}{-1.5ex}')
        exo.append(u'Dresser le tableau de variations de chacune des fonctions suivantes.\\par')

        exo.append('\\begin{align*}')
        noms = [r'f\,(x) &= ', r'g\,(x) &= ', r'h\,(x) &= ', r'i\,(x) &= ']
        r = []
        for i in range(3):
            r.append(noms[i] + str(self.exercice[i]))
        
        exo.append(' &\n'.join(r))
        exo.append('\\end{align*}')
        return exo
